package ch.polgrabia.demos.server;

import ch.polgrabia.demos.client.WebsocketClientApp;
import io.vertx.core.Handler;
import io.vertx.core.http.ServerWebSocket;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

public class WebsocketServerHandler implements Handler<ServerWebSocket> {
    private static final Logger logger = LoggerFactory.getLogger(WebsocketClientApp.class);

    @Override
    public void handle(ServerWebSocket serverWebSocket) {
        serverWebSocket.writeTextMessage("Hello");
        serverWebSocket.textMessageHandler(new WebsocketTextMessageHandler(serverWebSocket));
    }

    static class WebsocketTextMessageHandler implements Handler<String> {

        private final ServerWebSocket serverWebSocket;

        public WebsocketTextMessageHandler(ServerWebSocket serverWebSocket) {
            this.serverWebSocket = serverWebSocket;
        }

        @Override
        public void handle(String s) {
            logger.info("Got message {}", s);
            serverWebSocket.writeTextMessage("Pong: " + s); // TBD send to kafka
        }
    }

}
